package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/environments"
	"git.perx.ru/perxis/perxis-go/pkg/environments/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	pb "git.perx.ru/perxis/perxis-go/proto/environments"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc environments.Environments, opts ...grpckit.ServerOption) pb.EnvironmentsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint:      grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint:      grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		GetEndpoint:         grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListEndpoint:        grpcerr.ServerMiddleware(eps.ListEndpoint),
		MigrateEndpoint:     grpcerr.ServerMiddleware(eps.MigrateEndpoint),
		RemoveAliasEndpoint: grpcerr.ServerMiddleware(eps.RemoveAliasEndpoint),
		SetAliasEndpoint:    grpcerr.ServerMiddleware(eps.SetAliasEndpoint),
		UpdateEndpoint:      grpcerr.ServerMiddleware(eps.UpdateEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
